<template>
  <v-row justify="center" no-gutters>
    <v-card style="width: 100%">
      <v-toolbar style="position:relative" color="white" elevation="0">
        <v-spacer />
        <v-toolbar-title class="mt-5">
          <span class="primary--text">
            <v-icon large color="primary" class="mr-2 pb-1">mdi-card-text</v-icon><b>{{ title }}</b>
          </span>
        </v-toolbar-title>
        <v-spacer />
        <v-tooltip color="red" bottom>
          <template v-slot:activator="{ on }">
            <v-icon
              v-on="on"
              style="position:absolute; right: 15px"
              color="red"
              @click="handleClose"
              >mdi-close</v-icon
            >
          </template>
          <span><b>Fechar</b> janela</span>
        </v-tooltip>
      </v-toolbar>
      <!-- Edit mode -->
      <div class="scrollForm">
        <FormatedMessage
          ref="form"
          :editing="editing"
          :buttonLabel="buttonLabel"
          :addEditMode="addEditMode"
          @cancelReply="handleClose"
          @sendedMsg="confirm"
        />
      </div>
    </v-card>
  </v-row>
</template>

<script>
import FormatedMessage from '@/components/FormatedMessage.vue'
import CollaborativeWork from '../../services/collaborativeWork'
export default {
  name: 'TeamReply',

  components: {
    FormatedMessage,
  },

  props: {
    infoTeamReply: { type: Object, default: {} },
  },
  data: () => ({
    title: 'Resposta da equipe',
    buttonLabel: 'Enviar',
    editing: {},
    userLogged: {},
    itemToDelete: '',
    addEditMode: '',
  }),

  computed: {
    checkDialogIsActive() {
      return this.$store.state.user.closeDialog
    },
    checkPermissions() {
      // usar checkPermissions.get('nome da permissão')
      return this.$store.state.user.mappedActions
    },
  },

  watch: {
    checkDialogIsActive() {
      if (this.checkDialogIsActive) {
        this.handleClose()
        this.$store.commit('user/UPDATE_CLOSE_DIALOG', false)
      }
    },
  },

  async created() {
    const userInfo = await this.$getItem('userInfo')
    this.userLogged = userInfo
  },

  methods: {
    //frontend

    handleClose() {
      this.$emit('closeMessage')
      this.$refs.form.cleanData()
    },

    async confirm(item) {
      const routedEntity = await this.$getItem('routedEntity')
      const role = routedEntity.privileges.label
      let reply = {
        collaborativeWorkAnswerId: this.infoTeamReply.collaborativeWorkAnswerId,
        teamId: this.infoTeamReply.teamId,
        answer: { title: item.title, comment: item.message },
        userLabel: role,
      }
      this.replyAnswerBackend(reply)
    },

    //backend

    async replyAnswerBackend(reply) {
      let ret
      try {
        this.$store.commit('user/UPDATE_LOADING', true)

        const routedEntity = await this.$getItem('routedEntity')
        const actionsMap = this.$store.state.user.mappedActions
        const actionId = actionsMap.get('collaborativeWorkAnswerCreate').id

        ret = await CollaborativeWork.replyAnswer(routedEntity.id, actionId, reply)

        if (ret.success) {
          console.log(ret, 'o que encontra ao responder')
          this.handleClose()
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Resposta <b>enviada</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
          this.$emit('refreshTeamAnswers')
        } else {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Desculpe não foi possível enviar a <b>resposta</b>!',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
      return ret
    },
  },
}
</script>

<style>
.bold {
  font-weight: 501;
}
.styleTC {
  font-size: 1rem;
  font-weight: 300;
  line-height: 1.35rem;
}
.hoverReply > .v-icon:hover {
  color: #ffc107 !important;
}
.menuOn {
  animation: menuAppears 0.5s;
}

@keyframes menuAppears {
  from {
    transform: translateY(-35px);
    opacity: 0;
  }

  to {
    transform: translateY(0);
    opacity: 1;
  }
}
.buttonHoverTC > span > .v-btn:hover {
  background: #2a0845 !important;
  color: white !important;
}
</style>
